<?php
/**
* @version		1.0
* @author		Mike K (AZ Web Designs)
* @copyright	Mike K (AZ Web Designs)
* @license		GNU/GPLv2
*/

/*
Any Server Status Module for Joomla!
Copyright (C) 2019  Mike K (AZ Web Designs)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

//no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;

//get the module class designation
$moduleclass_sfx = htmlspecialchars($params->get('moduleclass_sfx'));

?>

<!DOCTYPE html>
<html lang="en">

<head>
	<title>Server Status Monitor</title>
	<meta content="text/html" charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">

	<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.2.1/css/bootstrap.min.css" integrity="sha384-GJzZqFGwb1QTTN6wy59ffF1BuGJpLSa9DkKMp0DgiMDm4iYMj70gZWKYbI706tWS" crossorigin="anonymous">
	
	<style>
	pre {
    overflow-x: auto;
	max-width: 60vw;
	}
	pre code {
    word-wrap: normal;
    white-space: pre;
	}
	.table-success {
		background-color: #c3e6cb !important;
	}
	.table-danger {
		background-color: #f5c6cb !important;
	}
	</style>
</head>

<html>
<div class="container">
<div class="<?php echo $moduleclass_sfx;?>">

<?php
//get all config data from db params
$server = $params->get('ass_server');
$service_internet = $params->get('ass_service_internet');
$service_internet_port = $params->get('ass_service_internet_port');
$service_ftp = $params->get('ass_service_ftp');
$service_ftp_port = $params->get('ass_service_ftp_port');
$service_sql = $params->get('ass_service_sql');
$service_sql_port = $params->get('ass_service_sql_port');
$service_mail = $params->get('ass_service_mail');
$service_mail_port = $params->get('ass_service_mail_port');
$service_disk = $params->get('ass_service_disk');
$service_ram = $params->get('ass_service_ram');
$service_speed = $params->get('ass_service_speed');
//$service_ram_user = $params->get('ass_service_ram_user');
//$service_cpu_user = $params->get('ass_service_cpu_user');


$loaddesc = "<small> &nbsp; [call] &nbsp; [load] &nbsp; [reply]</small>"; //labels for server load times
$tnow = date('l M d, Y @ h:i:s'); //get todays date and time
$timenow = "<font size=2>$tnow</font size>"; //display todays date and time
$active = "Active";



/********************** Begin Processing Everything ************************/
$data = "";

/*********************************** Start Top Display Area - Live Server Status Services ***********************************/
$data .= '<div class="card my-2"><h4 class="card-header text-center">Live Server Status<br />'.$timenow.'</h4><div class="card-body pb-0">';

$timeout = "1";

// set a variable for each service array
$web_server = array("port" => "80",  "service" => "Web Server",  "ip" => "$server");
$internet = array("port" => "80",  "service" => "Internet Connection",  "ip" => "$server");
$ftp_server = array("port" => "21",  "service" => "FTP",  "ip" => "$server");
$mysql = array("port" => "3306",  "service" => "MySQL",  "ip" => "$server");
$mail_server = array("port" => "110",  "service" => "Mail Server",  "ip" => "$server");
$open_ssh = array("port" => "22",  "service" => "Open SSH",  "ip" => "$server");


/*********** Internet Config Checks **************/
if ($service_internet == "1" && $service_internet_port == "0") {
	$internet['port'] = "";
	$port = "80";
	$internet['ip'] = $server;
	}

if ($service_internet == "1" && $service_internet_port == "1") {
	$port = "80";
	}

if ($service_internet == "0" && $service_internet_port == "0") {
	$error_int = "2";
	}

/*********** FTP Config Checks **************/
if ($service_ftp == "1" && $service_ftp_port == "0") {
	$ftp_server['port'] = "";
	$port = "21";
	$ftp_server['ip'] = $server;
	}

if ($service_ftp == "1" && $service_ftp_port == "1") {
	$port = "21";
	}

if ($service_ftp == "0" && $service_ftp_port == "0") {
	$error_ftp = "3";
	}

/*********** MySQL Config Checks **************/
if ($service_sql == "1" && $service_sql_port == "0") {
	$mysql['port'] = "";
	$port = "3306";
	$mysql['ip'] = $server;
	}

if ($service_sql == "1" && $service_sql_port == "1") {
	$port = "3306";
	}

if ($service_sql == "0" && $service_sql_port == "0") {
	$error_msql = "4";
	}

/*********** Mail Server Config Checks **************/
if ($service_mail == "1" && $service_mail_port == "0") {
	$mail_server['port'] = "";
	$port = "110";
	$mail_server['ip'] = $server;
	}

if ($service_mail == "1" && $service_mail_port == "1") {
	$port = "110";
	}

if ($service_mail == "0" && $service_mail_port == "0") {
	$error_mail = "5";
	}



$data .= "<table class='table table-sm '><thead><tr><th width=47%>Service</th><th width=25%>Port</th><th>Status</th></tr></thead>";


//Web Server Status
$data .= "<tr><td>" . $web_server['service'] . "</td><td>".$web_server['port'];
	$fp = @fsockopen($server, $web_server['port'], $errno, $errstr, $timeout);

	if (!$fp) {
		$data .= "</td><td class='table-danger'><font color=red>Offline</font color></td></tr>";
	} else {
		$data .= "</td><td class='table-success'><font color=green>Online</font color></td></tr>";
		fclose($fp);
	}

//Internet Connection Status
if ($error_int == "2") {
} else {
$data .= "<tr><td>" . $internet['service'] . "</td><td>".$internet['port'];
	$fp = @fsockopen($server, $port, $errno, $errstr, $timeout);

	if (!$fp) {
		$data .= "</td><td class='table-danger'><font color=red>Offline</font color></td></tr>";
	} else {
		$data .= "</td><td class='table-success'><font color=green>Online</font color></td></tr>";
		fclose($fp);
	}
}

//FTP Server Status
if ($error_ftp == "3") {
} else {
$data .= "<tr><td>" . $ftp_server['service'] . "</td><td>".$ftp_server['port'];
	$fp = @fsockopen($server, $port, $errno, $errstr, $timeout);

	if (!$fp) {
		$data .= "</td><td class='table-danger'><font color=red>Offline</font color></td></tr>";
	} else {
		$data .= "</td><td class='table-success'><font color=green>Online</font color></td></tr>";
		fclose($fp);
	}
}

//MySQL Status
if ($error_msql == "4") {
} else {
$data .= "<tr><td>" . $mysql['service'] . "</td><td>".$mysql['port'];
	$fp = @fsockopen($server, $port, $errno, $errstr, $timeout);

	if (!$fp) {
		$data .= "</td><td class='table-danger'><font color=red>Offline</font color></td></tr>";
	} else {
		$data .= "</td><td class='table-success'><font color=green>Online</font color></td></tr>";
		fclose($fp);
	}
}

//Mail Server Status
if ($error_mail == "5") {
} else {
$data .= "<tr><td>" . $mail_server['service'] . "</td><td>".$mail_server['port'];
	$fp = @fsockopen($server, $port, $errno, $errstr, $timeout);

	if (!$fp) {
		$data .= "</td><td class='table-danger'><font color=red>Offline</font color></td></tr>";
	} else {
		$data .= "</td><td class='table-success'><font color=green>Online</font color></td></tr>";
		fclose($fp);
	}
}

//Open SSH Status
/*
$data .= "<tr><td>" . $open_ssh['service'] . "</td><td>".$open_ssh['port'];
	$fp = @fsockopen($server, $open_ssh['port'], $errno, $errstr, $timeout);

	if (!$fp) {
		$data .= "</td><td class='table-danger'><font color=red>Offline</font color></td></tr>";
	} else {
		$data .= "</td><td class='table-success'><font color=green>Online</font color></td></tr>";
		fclose($fp);
	}
*/

$data .= "</table>";
$data .= '
  </div>
</div>
';
echo $data;
/**************** End Top Live Server Status Table Area *******************/





/*********************************************Start Bottom Live Server Performance Area  ************************************/

//GET SERVER LOADS
$loadresult = @exec('uptime');  
preg_match("/averages?: ([0-9\.]+),[\s]+([0-9\.]+),[\s]+([0-9\.]+)/",$loadresult,$avgs);

//GET SERVER UPTIME
$uptime = explode(' up ', $loadresult);
$uptime = explode(',', $uptime[1]);
$uptime = $uptime[0].', '.$uptime[1];

//Get the disk space
function getSymbolByQuantity($bytes) {
	$symbol = array('B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');
	$exp = floor(log($bytes)/log(1024));
	
	return sprintf('%.2f<small>'.$symbol[$exp].'</small>', ($bytes/pow(1024, floor($exp))));
}

function percent_to_color($p){
	if($p < 30) return 'success';
	if($p < 45) return 'info';
	if($p < 60) return 'primary';
	if($p < 75) return 'warning';
	return 'danger';
}

function format_storage_info($disk_space, $disk_free, $disk_name){
	$str = "";
	$disk_free_precent = 100 - round($disk_free*1.0 / $disk_space*100, 2);
		$str .= '<div class="col p-0 d-inline-flex">';
		$str .= "<span class='mr-2'>" . badge($disk_name,'secondary') .' '. getSymbolByQuantity($disk_free) . '/'. getSymbolByQuantity($disk_space) ."</span>";
		$str .= '<div class="progress flex-grow-1 align-self-center" style="height: 25px;"><div class="progress-bar progress-bar-striped progress-bar-animated ';
		$str .= 'bg-' . percent_to_color($disk_free_precent) .'" role="progressbar" style="width: '.$disk_free_precent.'%;" aria-valuenow="'.$disk_free_precent.'" aria-valuemin="0"  aria-valuemax="100">'.$disk_free_precent.'%</div>
		</div>
		</div>';
	return $str;
}

function get_disk_free_status($disks){
	$str="";
	$max = 5;
	foreach($disks as $disk){
		if(strlen($disk["name"]) > $max) 
			$max = strlen($disk["name"]);
	}
	
	foreach($disks as $disk){
		$disk_space = disk_total_space($disk["path"]);
		$disk_free = disk_free_space($disk["path"]);
		$str .= format_storage_info($disk_space, $disk_free, $disk['name']);
	}
	return $str;
}

function badge($str, $type){
	return "<span class='badge badge-" . $type . " ' >$str</span>";
	}

//Get ram usage
$total_mem = preg_split('/ +/', @exec('grep MemTotal /proc/meminfo'));
$total_mem = $total_mem[1];
$free_mem = preg_split('/ +/', @exec('grep MemFree /proc/meminfo'));
$cache_mem = preg_split('/ +/', @exec('grep ^Cached /proc/meminfo'));
$free_mem = $free_mem[1] + $cache_mem[1];

//Get top memory usage
$tom_mem_arr = array();
$top_cpu_use = array();

$i = 5; // the number of processes to display in Top RAM user

/* ps command:
-e to display process from all users
-k to specify sorting order: - is desc order follow by column name
-o to specify output format, it's a list of column name. = suppress the display of column name
head to get only the first few lines 
*/
exec("ps -e k-rss -o rss,args | head -n $i", $tom_mem_arr, $status);
exec("ps -e k-pcpu -o pcpu,args | head -n $i", $top_cpu_use, $status);
$top_mem = implode('<br/>', $tom_mem_arr );
$top_mem = "<pre class='mb-0 '><code>" . $top_mem . "</code></pre>";
$top_cpu = implode('<br/>', $top_cpu_use );
$top_cpu = "<pre class='mb-0 '><code>" . $top_cpu. "</code></pre>";

//calculate Internet Speed
function microtime_diff($a, $b) {
list($a_dec, $a_sec) = explode(" ", $a);
list($b_dec, $b_sec) = explode(" ", $b);
return $b_sec - $a_sec + $b_dec - $a_dec;
}

function test_speed($test_size) {
flush();
$start_time = microtime();
$comment = "<!--O-->";
$len = strlen($comment);
for($i = 0; $i < $test_size; $i += $len) {
echo $comment;
}

flush();
$duration = microtime_diff($start_time, microtime());
if($duration != 0) {
return $test_size / $duration / 1024;
	}
else {
return log(0);
	}
}

$speed = test_speed(1024);
if($speed > 50) { // a fast connection, send more bytes for more accuracy
$speed = test_speed(10240);
$speed = round(($speed / 1024),2); //make it MB/sec
if($speed > 500) { // a really fast connection, send even more bytes for more accuracy
$speed = test_speed(102400);
$speed = round(($speed / 1024),2); //make it MB/sec
	}
	}
// end calculate Internet Speed



/***************** Output The Data into Bottom Table ****************/

$data1 = "";
$data1 .= '<div class="card mb-2"><h4 class="card-header text-center">Live Server Performance<br />'.$timenow.'</h4><div class="card-body pb-0">';


/*********** Disk Config Check **************/
if ($service_disk == "0") {
	$error2 = "6";
	}

/*********** Ram Config Check **************/
if ($service_ram == "0") {
	$error3 = "7";
	}

/*********** Speed Config Check **********/
if ($service_speed == "0") {
	$error4 = "11";
	}



$data1 .= "<table class='table table-sm mb-0'>";


//Load Times Row
$data1 .= "<tr><td width=47%>Average Load Time</td><td><h5>". badge($avgs[1],'secondary'). ' ' .badge($avgs[2], 'secondary') . ' ' . badge( $avgs[3], 'secondary') . "$loaddesc<br />$toppercent </h5></td>\n";

//Internet Speed Row
if ($error4 == "11") {
	} else {
$data1 .= "<tr><td>Server Internet Speed</td><td>$speed MB/sec</td></tr>";
	}

//Uptime Row
$data1 .= "<tr><td>Uptime</td><td>$uptime</td></tr>";

//Disk Usage Row
if ($error2 == "6") {
	} else {
	$disks = array();
	$disks[] = array("name" => "local" , "path" => getcwd()) ;
	// $disks[] = array("name" => "Your disk name" , "path" => '/mount/point/to/that/disk') ;
	$data1 .= "<tr><td>Disk (Free/Total)</td><td>" . get_disk_free_status($disks) . "</td></tr>";
	}

//Ram Usage Row
if ($error3 == "7") {
	} else {
	$data1 .= "<tr><td>RAM (Free/Total)</td><td>". format_storage_info($total_mem *1024, $free_mem *1024, '') ."</td></tr>";
}

//Top Ram and CPU Users
//$data1 .= "<tr><td>Top RAM User</td><td><small>$top_mem</small></td></tr>";
//$data1 .= "<tr><td>Top CPU User</td><td><small>$top_cpu</small></td></tr>";


$data1 .= "</table>";
$data1 .= '</div>';
echo $data1;


?>

  </div>
 </div>
</html>